<' 
method_type set_dut_ins(data: dut_instruction); 
type opcodes: [add, sub, nop](bits: 8); 
 
struct dut_instruction { 
  %opcode: opcodes; 
    when add'opcode dut_instruction { 
      %addr1: uint(bits: 24); 
      keep addr1 in [0..63]; 
      %addr2: uint(bits: 24); 
      keep addr2 in [0..63]; 
  }; 
}; 
 
extend sys { 
  u: verifier is instance; 
    keep u.hdl_path() == "top"; 
}; 
 
unit verifier { 
  set_instruction: out method_port of set_dut_ins is instance; 
    keep set_instruction.hdl_path() == "set_ins"; 
 
  instructions: list of dut_instruction; 
    keep instructions.size() == 5; 
 
  clk: in event_port is instance; 
    keep clk.hdl_path() == "clk"; 
     
  verify() @clk$ is { 
    for each in instructions { 
      set_instruction$(it); 
      wait cycle; 
    }; 
    stop_run(); 
  }; 
  run() is also { 
    start verify(); 
  }; 
}; 
'>	 
